<html>
<head>
<title>OgreCompositionTargetPass.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreCompositionTargetPass.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreCompositionTargetPass_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __CompositionTargetPass_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __CompositionTargetPass_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00044"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html">00044</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1CompositionTargetPass.html" title="Object representing one render to a RenderTarget or Viewport in the Ogre Composition framework...">CompositionTargetPass</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">CompositorInstAlloc</a>
<a name="l00045"></a>00045     {
<a name="l00046"></a>00046     <span class="keyword">public</span>:
<a name="l00047"></a>00047         <a class="code" href="classOgre_1_1CompositionTargetPass.html" title="Object representing one render to a RenderTarget or Viewport in the Ogre Composition framework...">CompositionTargetPass</a>(<a class="code" href="classOgre_1_1CompositionTechnique.html" title="Base composition technique, can be subclassed in plugins.">CompositionTechnique</a> *parent);
<a name="l00048"></a>00048         ~<a class="code" href="classOgre_1_1CompositionTargetPass.html" title="Object representing one render to a RenderTarget or Viewport in the Ogre Composition framework...">CompositionTargetPass</a>();
<a name="l00049"></a>00049         
<a name="l00052"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html#ab2b5ca61fda0a8dfdba1e3447f453294">00052</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1CompositionTargetPass.html#ab2b5ca61fda0a8dfdba1e3447f453294" title="Input mode of a TargetPass.">InputMode</a>
<a name="l00053"></a>00053         {
<a name="l00054"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html#ab2b5ca61fda0a8dfdba1e3447f453294a97eecad4dbc7cc768152365585fa9fe6">00054</a>             <a class="code" href="classOgre_1_1CompositionTargetPass.html#ab2b5ca61fda0a8dfdba1e3447f453294a97eecad4dbc7cc768152365585fa9fe6">IM_NONE</a>,        <span class="comment">// No input</span>
<a name="l00055"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html#ab2b5ca61fda0a8dfdba1e3447f453294a412bc35d7930bd2101ea4d0a5a760611">00055</a>             IM_PREVIOUS     <span class="comment">// Output of previous Composition in chain</span>
<a name="l00056"></a>00056         };
<a name="l00057"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html#ae4c3411ea5a627769c7bf65179b6b5d6">00057</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;CompositionPass *&gt;::type</a> <a class="code" href="classOgre_1_1CompositionTargetPass.html#ae4c3411ea5a627769c7bf65179b6b5d6">Passes</a>;
<a name="l00058"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html#a1b8ac16663ae6c9fc06c80159f87d51b">00058</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator&lt;Passes&gt;</a> <a class="code" href="classOgre_1_1CompositionTargetPass.html#a1b8ac16663ae6c9fc06c80159f87d51b">PassIterator</a>;
<a name="l00059"></a>00059         
<a name="l00062"></a>00062         <span class="keywordtype">void</span> setInputMode(<a class="code" href="classOgre_1_1CompositionTargetPass.html#ab2b5ca61fda0a8dfdba1e3447f453294" title="Input mode of a TargetPass.">InputMode</a> mode);
<a name="l00064"></a>00064         <a class="code" href="classOgre_1_1CompositionTargetPass.html#ab2b5ca61fda0a8dfdba1e3447f453294" title="Input mode of a TargetPass.">InputMode</a> getInputMode() <span class="keyword">const</span>;
<a name="l00065"></a>00065         
<a name="l00067"></a>00067         <span class="keywordtype">void</span> setOutputName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;out);
<a name="l00069"></a>00069         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;getOutputName() <span class="keyword">const</span>;
<a name="l00070"></a>00070         
<a name="l00074"></a>00074         <span class="keywordtype">void</span> setOnlyInitial(<span class="keywordtype">bool</span> value);
<a name="l00077"></a>00077         <span class="keywordtype">bool</span> getOnlyInitial();
<a name="l00078"></a>00078         
<a name="l00081"></a>00081         <span class="keywordtype">void</span> setVisibilityMask(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> mask);
<a name="l00084"></a>00084         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getVisibilityMask();
<a name="l00085"></a>00085 
<a name="l00092"></a>00092         <span class="keywordtype">void</span> setMaterialScheme(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; schemeName);
<a name="l00099"></a>00099         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMaterialScheme(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00100"></a>00100         
<a name="l00106"></a>00106         <span class="keywordtype">void</span> setShadowsEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00112"></a>00112         <span class="keywordtype">bool</span> getShadowsEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00116"></a>00116         <span class="keywordtype">void</span> setLodBias(<span class="keywordtype">float</span> bias);
<a name="l00119"></a>00119         <span class="keywordtype">float</span> getLodBias();
<a name="l00120"></a>00120         
<a name="l00123"></a>00123         <a class="code" href="classOgre_1_1CompositionPass.html" title="Object representing one pass or operation in a composition sequence.">CompositionPass</a> *createPass();
<a name="l00126"></a>00126         <span class="keywordtype">void</span> removePass(<span class="keywordtype">size_t</span> idx);
<a name="l00129"></a>00129         <a class="code" href="classOgre_1_1CompositionPass.html" title="Object representing one pass or operation in a composition sequence.">CompositionPass</a> *getPass(<span class="keywordtype">size_t</span> idx);
<a name="l00132"></a>00132         <span class="keywordtype">size_t</span> getNumPasses();
<a name="l00133"></a>00133         
<a name="l00136"></a>00136         <span class="keywordtype">void</span> removeAllPasses();
<a name="l00137"></a>00137     
<a name="l00139"></a>00139         <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">PassIterator</a> getPassIterator(<span class="keywordtype">void</span>);
<a name="l00140"></a>00140         
<a name="l00142"></a>00142         <a class="code" href="classOgre_1_1CompositionTechnique.html" title="Base composition technique, can be subclassed in plugins.">CompositionTechnique</a> *getParent();
<a name="l00143"></a>00143 
<a name="l00146"></a>00146         <span class="keywordtype">bool</span> _isSupported(<span class="keywordtype">void</span>);
<a name="l00147"></a>00147 
<a name="l00148"></a>00148     <span class="keyword">private</span>:
<a name="l00150"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html#a59453821f88399703dae5e7ced4c47bd">00150</a>         <a class="code" href="classOgre_1_1CompositionTechnique.html" title="Base composition technique, can be subclassed in plugins.">CompositionTechnique</a> *<a class="code" href="classOgre_1_1CompositionTargetPass.html#a59453821f88399703dae5e7ced4c47bd" title="Parent technique.">mParent</a>;
<a name="l00152"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html#a459ee451d7916398cca6bc300b0ac7c6">00152</a>         <a class="code" href="classOgre_1_1CompositionTargetPass.html#ab2b5ca61fda0a8dfdba1e3447f453294" title="Input mode of a TargetPass.">InputMode</a> <a class="code" href="classOgre_1_1CompositionTargetPass.html#a459ee451d7916398cca6bc300b0ac7c6" title="Input name.">mInputMode</a>;
<a name="l00154"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html#a6ff0106b3d9aaaccf9f4a76885cdbbf2">00154</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1CompositionTargetPass.html#a6ff0106b3d9aaaccf9f4a76885cdbbf2" title="(local) output texture">mOutputName</a>;
<a name="l00156"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html#a2f52450762b8bebd7d1154fd4f840456">00156</a>         <a class="code" href="classOgre_1_1CompositionTargetPass.html#ae4c3411ea5a627769c7bf65179b6b5d6">Passes</a> <a class="code" href="classOgre_1_1CompositionTargetPass.html#a2f52450762b8bebd7d1154fd4f840456" title="Passes.">mPasses</a>;
<a name="l00159"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html#a7d4c5bd17e2e323f1d0d1ef267f8fd61">00159</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositionTargetPass.html#a7d4c5bd17e2e323f1d0d1ef267f8fd61" title="This target pass is only executed initially after the effect has been enabled.">mOnlyInitial</a>;
<a name="l00161"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html#a191a14c4f7e8b5c55b6af2b6711d0810">00161</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1CompositionTargetPass.html#a191a14c4f7e8b5c55b6af2b6711d0810" title="Visibility mask for this render.">mVisibilityMask</a>;
<a name="l00163"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html#a4ce2db808cd0fdfffbe1711e2160bfc5">00163</a>         <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1CompositionTargetPass.html#a4ce2db808cd0fdfffbe1711e2160bfc5" title="LOD bias of this render.">mLodBias</a>;
<a name="l00165"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html#abd072b22313d02b789cf35c82e38b811">00165</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1CompositionTargetPass.html#abd072b22313d02b789cf35c82e38b811" title="Material scheme name.">mMaterialScheme</a>;
<a name="l00167"></a><a class="code" href="classOgre_1_1CompositionTargetPass.html#a7562d96ff4c451bf72ce604f11623906">00167</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositionTargetPass.html#a7562d96ff4c451bf72ce604f11623906" title="Shadows option.">mShadowsEnabled</a>;
<a name="l00168"></a>00168     };
<a name="l00169"></a>00169 
<a name="l00172"></a>00172 }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
